/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : PIT.h
**     Project     : CM-K60D
**     Processor   : MK64FN1M0VLQ12
**     Component   : Init_PIT
**     Version     : Component 01.006, Driver 01.06, CPU db: 3.00.000
**     Repository  : Kinetis
**     Compiler    : GNU C Compiler
**     Date/Time   : 2015-07-30, 16:10, # CodeGen: 0
**     Abstract    :
**          This file implements the PIT (PIT) module initialization
**          according to the Peripheral Initialization settings, and
**          defines interrupt service routines prototypes.
**     Settings    :
**          Component name                                 : PIT
**          Device                                         : PIT
**          Setttings                                      : 
**            Clock gate                                   : Enabled
**            Clock settings                               : 
**              Base clock frequency                       : 20.972 MHz
**            Freeze in debug mode                         : no
**          Channels                                       : 
**            Channel 0                                    : 
**              Timer 0                                    : Enabled
**              Timer 0 load value                         : 20833
**              Timer 0 Period                             : 993.443 us
**              Interrupt                                  : 
**                Interrupt                                : INT_PIT0
**                Interrupt request                        : Enabled
**                Interrupt priority                       : <Automatic>
**                ISR Name                                 : pit0_isr
**                Timer interrupt                          : Enabled
**            Channel 1                                    : 
**              Timer 1                                    : Enabled
**              Timer 1 chain mode                         : Disabled
**              Timer 1 load value                         : 163
**              Timer 1 Period                             : 7.820 us
**              Interrupt                                  : 
**                Interrupt                                : INT_PIT1
**                Interrupt request                        : Enabled
**                Interrupt priority                       : <Automatic>
**                ISR Name                                 : pit1_isr
**                Timer interrupt                          : Enabled
**            Channel 2                                    : 
**              Timer 2                                    : Disabled
**              Timer 2 chain mode                         : Disabled
**              Timer 2 load value                         : 0
**              Timer 2 Period                             : 0.048 us
**              Interrupt                                  : 
**                Interrupt                                : INT_PIT2
**                Interrupt request                        : <Automatic>
**                Interrupt priority                       : <Automatic>
**                ISR Name                                 : 
**                Timer interrupt                          : Disabled
**            Channel 3                                    : 
**              Timer 3                                    : Disabled
**              Timer 3 chain mode                         : Disabled
**              Timer 3 load value                         : 0
**              Timer 3 Period                             : 0.048 us
**              Interrupt                                  : 
**                Interrupt                                : INT_PIT3
**                Interrupt request                        : <Automatic>
**                Interrupt priority                       : <Automatic>
**                ISR Name                                 : 
**                Timer interrupt                          : Disabled
**          Initialization                                 : 
**            Module                                       : Enabled
**            Call Init method                             : yes
**            Utilize after reset values                   : default
**     Contents    :
**         Init - void PIT_Init(void);
**
**     Copyright : 1997 - 2015 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file PIT.h
** @version 01.06
** @brief
**          This file implements the PIT (PIT) module initialization
**          according to the Peripheral Initialization settings, and
**          defines interrupt service routines prototypes.
*/         
/*!
**  @addtogroup PIT_module PIT module documentation
**  @{
*/         

#ifndef PIT_H_
#define PIT_H_

/* MODULE PIT. */

#include "PIT_Init.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Initialization method user name */
#define PIT_Init PIT_Init
/* PDD macros peripheral base address parameter */
#define PIT_DEVICE PIT_BASE_PTR
/*
** ===================================================================
** The interrupt service routine must be implemented by user in one
** of the user modules (see PIT.c file for more information).
** ===================================================================
*/
PE_ISR(pit0_isr);
/*
** ===================================================================
** The interrupt service routine must be implemented by user in one
** of the user modules (see PIT.c file for more information).
** ===================================================================
*/
PE_ISR(pit1_isr);

#ifdef __cplusplus
}
#endif

/* END PIT. */
#endif /* #ifndef __PIT_H_ */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.5 [05.21]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/


