/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : ShieldGPIOB.c
**     Project     : CM-K60D
**     Processor   : MK64FN1M0VLQ12
**     Component   : GPIO_LDD
**     Version     : Component 01.128, Driver 01.08, CPU db: 3.00.000
**     Repository  : Kinetis
**     Compiler    : GNU C Compiler
**     Date/Time   : 2015-07-30, 16:10, # CodeGen: 0
**     Abstract    :
**         The HAL GPIO component will provide a low level API for unified
**         access to general purpose digital input/output pins across
**         various device designs.
**
**         RTOS drivers using HAL GPIO API will be simpler and more
**         portable to various microprocessors.
**     Settings    :
**          Component name                                 : ShieldGPIOB
**          Port                                           : PTB
**          Port width                                     : 32 bits
**          Mask of allocated pins                         : 0x800200
**          Interrupt service/event                        : Disabled
**          Bit fields                                     : 2
**            Bit field                                    : 
**              Field name                                 : ShieldD2
**              Pins                                       : 1
**                Pin                                      : 
**                  Pin                                    : PTB9/SPI1_PCS1/UART3_CTS_b/FB_AD20
**                  Initial pin direction                  : Input
**                  Initial pin event                      : Disabled
**                  Lock initialization function           : no
**            Bit field                                    : 
**              Field name                                 : ShieldD4
**              Pins                                       : 1
**                Pin                                      : 
**                  Pin                                    : PTB23/SPI2_SIN/SPI0_PCS5/FB_AD28
**                  Initial pin direction                  : Input
**                  Initial pin event                      : Disabled
**                  Lock initialization function           : no
**          Initialization                                 : 
**            Auto initialization                          : yes
**            Event mask                                   : 
**              OnPortEvent                                : Disabled
**     Contents    :
**         Init                    - LDD_TDeviceData* ShieldGPIOB_Init(LDD_TUserData *UserDataPtr);
**         SetFieldValue           - void ShieldGPIOB_SetFieldValue(LDD_TDeviceData *DeviceDataPtr,...
**         GetFieldValue           - ShieldGPIOB_TFieldValue ShieldGPIOB_GetFieldValue(LDD_TDeviceData...
**         ClearFieldBits          - void ShieldGPIOB_ClearFieldBits(LDD_TDeviceData *DeviceDataPtr,...
**         SetFieldBits            - void ShieldGPIOB_SetFieldBits(LDD_TDeviceData *DeviceDataPtr,...
**         ToggleFieldBits         - void ShieldGPIOB_ToggleFieldBits(LDD_TDeviceData *DeviceDataPtr,...
**         SetFieldInputDirection  - void ShieldGPIOB_SetFieldInputDirection(LDD_TDeviceData *DeviceDataPtr,...
**         SetFieldOutputDirection - void ShieldGPIOB_SetFieldOutputDirection(LDD_TDeviceData *DeviceDataPtr,...
**
**     Copyright : 1997 - 2015 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file ShieldGPIOB.c
** @version 01.08
** @brief
**         The HAL GPIO component will provide a low level API for unified
**         access to general purpose digital input/output pins across
**         various device designs.
**
**         RTOS drivers using HAL GPIO API will be simpler and more
**         portable to various microprocessors.
*/         
/*!
**  @addtogroup ShieldGPIOB_module ShieldGPIOB module documentation
**  @{
*/         

/* MODULE ShieldGPIOB. */

#include "ShieldGPIOB.h"
/* {Default RTOS Adapter} No RTOS includes */
#include "IO_Map.h"

#ifdef __cplusplus
extern "C" {
#endif 

typedef struct {
  LDD_TUserData *UserData;             /* RTOS device data structure */
} ShieldGPIOB_TDeviceData, *ShieldGPIOB_TDeviceDataPtr; /* Device data structure type */
/* {Default RTOS Adapter} Static object used for simulation of dynamic driver memory allocation */
static ShieldGPIOB_TDeviceData DeviceDataPrv__DEFAULT_RTOS_ALLOC;
/*
** ===================================================================
**     Method      :  ShieldGPIOB_Init (component GPIO_LDD)
*/
/*!
**     @brief
**         This method initializes the associated peripheral(s) and the
**         component internal variables. The method is called
**         automatically as a part of the application initialization
**         code.
**     @param
**         UserDataPtr     - Pointer to the RTOS device
**                           structure. This pointer will be passed to
**                           all events as parameter.
**     @return
**                         - Pointer to the dynamically allocated private
**                           structure or NULL if there was an error.
*/
/* ===================================================================*/
LDD_TDeviceData* ShieldGPIOB_Init(LDD_TUserData *UserDataPtr)
{
  /* Allocate LDD device structure */
  ShieldGPIOB_TDeviceData *DeviceDataPrv;

  /* {Default RTOS Adapter} Driver memory allocation: Dynamic allocation is simulated by a pointer to the static object */
  DeviceDataPrv = &DeviceDataPrv__DEFAULT_RTOS_ALLOC;
  /* Save RTOS Device structure */
  DeviceDataPrv->UserData = UserDataPtr; /* Store the RTOS device structure */
  /* Enable device clock gate */
  /* SIM_SCGC5: PORTB=1 */
  SIM_SCGC5 |= SIM_SCGC5_PORTB_MASK;
  /* GPIOB_PDDR: PDD&=~0x00800200 */
  GPIOB_PDDR &= (uint32_t)~(uint32_t)(GPIO_PDDR_PDD(0x00800200));
  /* Initialization of pin routing */
  /* PORTB_PCR9: ISF=0,MUX=1 */
  PORTB_PCR9 = (uint32_t)((PORTB_PCR9 & (uint32_t)~(uint32_t)(
                PORT_PCR_ISF_MASK |
                PORT_PCR_MUX(0x06)
               )) | (uint32_t)(
                PORT_PCR_MUX(0x01)
               ));
  /* PORTB_PCR23: ISF=0,MUX=1 */
  PORTB_PCR23 = (uint32_t)((PORTB_PCR23 & (uint32_t)~(uint32_t)(
                 PORT_PCR_ISF_MASK |
                 PORT_PCR_MUX(0x06)
                )) | (uint32_t)(
                 PORT_PCR_MUX(0x01)
                ));
  /* Registration of the device structure */
  PE_LDD_RegisterDeviceStructure(PE_LDD_COMPONENT_ShieldGPIOB_ID,DeviceDataPrv);
  return ((LDD_TDeviceData *)DeviceDataPrv);
}

/*
** ===================================================================
**     Method      :  ShieldGPIOB_SetFieldValue (component GPIO_LDD)
*/
/*!
**     @brief
**         This method sets the output data value of the specified bit
**         field.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @param
**         Value           - Aligned data value to writting to the
**                           specified bit field. The bit 0 corresponds
**                           with the pin which has index 0 within the
**                           given bit field, the bit 1 corresponds with
**                           the pin which has index 1 within the given
**                           bit field, etc.
*/
/* ===================================================================*/
void ShieldGPIOB_SetFieldValue(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOB_TFieldValue Value)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD2: {                   /* bit field #0 */
      GPIO_PDD_SetPortDataOutput(ShieldGPIOB_MODULE_BASE_ADDRESS,
        (
          GPIO_PDD_GetPortDataOutput(ShieldGPIOB_MODULE_BASE_ADDRESS)
          & ((ShieldGPIOB_TPortValue)(~((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD2_MASK)))
        )
        | (
          ((ShieldGPIOB_TPortValue)(Value << ShieldGPIOB_ShieldD2_START_BIT))
          & ((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD2_MASK)
        )
      );
      break;
    }
    case ShieldD4: {                   /* bit field #1 */
      GPIO_PDD_SetPortDataOutput(ShieldGPIOB_MODULE_BASE_ADDRESS,
        (
          GPIO_PDD_GetPortDataOutput(ShieldGPIOB_MODULE_BASE_ADDRESS)
          & ((ShieldGPIOB_TPortValue)(~((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD4_MASK)))
        )
        | (
          ((ShieldGPIOB_TPortValue)(Value << ShieldGPIOB_ShieldD4_START_BIT))
          & ((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD4_MASK)
        )
      );
      break;
    }
    default:
      break;                           /* Invalid Field is not treated, result is undefined */
  } /* switch (Field) */
}

/*
** ===================================================================
**     Method      :  ShieldGPIOB_GetFieldValue (component GPIO_LDD)
*/
/*!
**     @brief
**         This method returns the current input data of the specified
**         field.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to reading. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @return
**                         - Aligned current port input value masked for
**                           allocated pins of the field. The bit 0
**                           corresponds with the pin which has index 0
**                           within the given bit field, the bit 1
**                           corresponds with the pin which has index 1
**                           within the given bit field, etc.
*/
/* ===================================================================*/
ShieldGPIOB_TFieldValue ShieldGPIOB_GetFieldValue(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD2: {                   /* bit field #0 */
      return
        (ShieldGPIOB_TFieldValue)(
          (
            GPIO_PDD_GetPortDataInput(ShieldGPIOB_MODULE_BASE_ADDRESS)
            & (ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD2_MASK
          )
          >> ShieldGPIOB_ShieldD2_START_BIT
        );
    }
    case ShieldD4: {                   /* bit field #1 */
      return
        (ShieldGPIOB_TFieldValue)(
          (
            GPIO_PDD_GetPortDataInput(ShieldGPIOB_MODULE_BASE_ADDRESS)
            & (ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD4_MASK
          )
          >> ShieldGPIOB_ShieldD4_START_BIT
        );
    }
    default:
      break;                           /* Invalid BitField is not treated, result is undefined */
  } /* switch (Field) */
  return (ShieldGPIOB_TFieldValue)0U;
}

/*
** ===================================================================
**     Method      :  ShieldGPIOB_ClearFieldBits (component GPIO_LDD)
*/
/*!
**     @brief
**         This method drives the specified bits of the specified bit
**         field to the inactive level.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @param
**         Mask            - Aligned mask of bits to setting the
**                           inactive level. Each field pin has
**                           corresponding bit in the mask. Bit value 0
**                           means not selected bit, bit value 1 means
**                           selected bit. The bit 0 corresponds with
**                           the pin which has index 0 within the given
**                           bit field, the bit 1 corresponds with the
**                           pin which has index 1 within the given bit
**                           field, etc.
*/
/* ===================================================================*/
void ShieldGPIOB_ClearFieldBits(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOB_TFieldValue Mask)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD2: {                   /* bit field #0 */
      GPIO_PDD_ClearPortDataOutputMask(ShieldGPIOB_MODULE_BASE_ADDRESS,
        ((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD2_MASK)
        & ((ShieldGPIOB_TPortValue)(Mask << ShieldGPIOB_ShieldD2_START_BIT))
      );
      break;
    }
    case ShieldD4: {                   /* bit field #1 */
      GPIO_PDD_ClearPortDataOutputMask(ShieldGPIOB_MODULE_BASE_ADDRESS,
        ((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD4_MASK)
        & ((ShieldGPIOB_TPortValue)(Mask << ShieldGPIOB_ShieldD4_START_BIT))
      );
      break;
    }
    default:
      break;                           /* Invalid Field is not treated, result is undefined */
  } /* switch (Field) */
}

/*
** ===================================================================
**     Method      :  ShieldGPIOB_SetFieldBits (component GPIO_LDD)
*/
/*!
**     @brief
**         This method drives the specified bits of the specified bit
**         field to the active level.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @param
**         Mask            - Aligned mask of bits to setting the
**                           active level. Each field pin has
**                           corresponding bit in the mask. Bit value 0
**                           means not selected bit, bit value 1 means
**                           selected bit. The bit 0 corresponds with
**                           the pin which has index 0 within the given
**                           bit field, the bit 1 corresponds with the
**                           pin which has index 1 within the given bit
**                           field, etc.
*/
/* ===================================================================*/
void ShieldGPIOB_SetFieldBits(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOB_TFieldValue Mask)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD2: {                   /* bit field #0 */
      GPIO_PDD_SetPortDataOutputMask(ShieldGPIOB_MODULE_BASE_ADDRESS,
        ((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD2_MASK)
        & ((ShieldGPIOB_TPortValue)(Mask << ShieldGPIOB_ShieldD2_START_BIT))
      );
      break;
    }
    case ShieldD4: {                   /* bit field #1 */
      GPIO_PDD_SetPortDataOutputMask(ShieldGPIOB_MODULE_BASE_ADDRESS,
        ((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD4_MASK)
        & ((ShieldGPIOB_TPortValue)(Mask << ShieldGPIOB_ShieldD4_START_BIT))
      );
      break;
    }
    default:
      break;                           /* Invalid Field is not treated, result is undefined */
  } /* switch (Field) */
}

/*
** ===================================================================
**     Method      :  ShieldGPIOB_ToggleFieldBits (component GPIO_LDD)
*/
/*!
**     @brief
**         This method inverts the specified bits of the specified bit
**         field to other level.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @param
**         Mask            - Aligned mask of bits to inverting the
**                           current level. Each field pin has
**                           corresponding bit in the mask. Bit value 0
**                           means not selected bit, bit value 1 means
**                           selected bit. The bit 0 corresponds with
**                           the pin which has index 0 within the given
**                           bit field, the bit 1 corresponds with the
**                           pin which has index 1 within the given bit
**                           field, etc.
*/
/* ===================================================================*/
void ShieldGPIOB_ToggleFieldBits(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOB_TFieldValue Mask)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD2: {                   /* bit field #0 */
      GPIO_PDD_TogglePortDataOutputMask(ShieldGPIOB_MODULE_BASE_ADDRESS,
        ((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD2_MASK)
        & ((ShieldGPIOB_TPortValue)(Mask << ShieldGPIOB_ShieldD2_START_BIT))
      );
      break;
    }
    case ShieldD4: {                   /* bit field #1 */
      GPIO_PDD_TogglePortDataOutputMask(ShieldGPIOB_MODULE_BASE_ADDRESS,
        ((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD4_MASK)
        & ((ShieldGPIOB_TPortValue)(Mask << ShieldGPIOB_ShieldD4_START_BIT))
      );
      break;
    }
    default:
      break;                           /* Invalid Field is not treated, result is undefined */
  } /* switch (Field) */
}

/*
** ===================================================================
**     Method      :  ShieldGPIOB_SetFieldInputDirection (component GPIO_LDD)
*/
/*!
**     @brief
**         This method sets all pins of the field to the input
**         direction.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
*/
/* ===================================================================*/
void ShieldGPIOB_SetFieldInputDirection(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD2: {                   /* bit field #0 */
      GPIO_PDD_SetPortInputDirectionMask(ShieldGPIOB_MODULE_BASE_ADDRESS,
        ShieldGPIOB_ShieldD2_MASK
      );
      break;
    }
    case ShieldD4: {                   /* bit field #1 */
      GPIO_PDD_SetPortInputDirectionMask(ShieldGPIOB_MODULE_BASE_ADDRESS,
        ShieldGPIOB_ShieldD4_MASK
      );
      break;
    }
    default:
      break;                           /* Invalid Field is not treated, result is undefined */
  } /* switch (Field) */
}

/*
** ===================================================================
**     Method      :  ShieldGPIOB_SetFieldOutputDirection (component GPIO_LDD)
*/
/*!
**     @brief
**         This method sets all pins of the field to the output
**         direction.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to set to the output
**                           direction. Bit fields are defined during
**                           design time and for each bit field there is
**                           a generated constant.
**     @param
**         Value           - Aligned data value to appear on the
**                           bit field pins after they have been
**                           switched to the output direction.
*/
/* ===================================================================*/
void ShieldGPIOB_SetFieldOutputDirection(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOB_TFieldValue Value)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD2: {                   /* bit field #0 */
      GPIO_PDD_SetPortDataOutput(ShieldGPIOB_MODULE_BASE_ADDRESS,
        ((ShieldGPIOB_TPortValue)(
          GPIO_PDD_GetPortDataOutput(ShieldGPIOB_MODULE_BASE_ADDRESS)
          & ((ShieldGPIOB_TPortValue)(
            ~((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD2_MASK)
          ))
        ))
        | (
          ((ShieldGPIOB_TPortValue)(Value << ShieldGPIOB_ShieldD2_START_BIT))
          & ((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD2_MASK)
        )
      );
      GPIO_PDD_SetPortOutputDirectionMask(ShieldGPIOB_MODULE_BASE_ADDRESS,
        ShieldGPIOB_ShieldD2_MASK
      );
      break;
    }
    case ShieldD4: {                   /* bit field #1 */
      GPIO_PDD_SetPortDataOutput(ShieldGPIOB_MODULE_BASE_ADDRESS,
        ((ShieldGPIOB_TPortValue)(
          GPIO_PDD_GetPortDataOutput(ShieldGPIOB_MODULE_BASE_ADDRESS)
          & ((ShieldGPIOB_TPortValue)(
            ~((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD4_MASK)
          ))
        ))
        | (
          ((ShieldGPIOB_TPortValue)(Value << ShieldGPIOB_ShieldD4_START_BIT))
          & ((ShieldGPIOB_TPortValue)ShieldGPIOB_ShieldD4_MASK)
        )
      );
      GPIO_PDD_SetPortOutputDirectionMask(ShieldGPIOB_MODULE_BASE_ADDRESS,
        ShieldGPIOB_ShieldD4_MASK
      );
      break;
    }
    default:
      break;                           /* Invalid Field is not treated, result is undefined */
  } /* switch (Field) */
}

/* END ShieldGPIOB. */

#ifdef __cplusplus
}  /* extern "C" */
#endif 

/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.5 [05.21]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
