/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : ShieldGPIOB.h
**     Project     : CM-K60D
**     Processor   : MK64FN1M0VLQ12
**     Component   : GPIO_LDD
**     Version     : Component 01.128, Driver 01.08, CPU db: 3.00.000
**     Repository  : Kinetis
**     Compiler    : GNU C Compiler
**     Date/Time   : 2015-07-30, 16:10, # CodeGen: 0
**     Abstract    :
**         The HAL GPIO component will provide a low level API for unified
**         access to general purpose digital input/output pins across
**         various device designs.
**
**         RTOS drivers using HAL GPIO API will be simpler and more
**         portable to various microprocessors.
**     Settings    :
**          Component name                                 : ShieldGPIOB
**          Port                                           : PTB
**          Port width                                     : 32 bits
**          Mask of allocated pins                         : 0x800200
**          Interrupt service/event                        : Disabled
**          Bit fields                                     : 2
**            Bit field                                    : 
**              Field name                                 : ShieldD2
**              Pins                                       : 1
**                Pin                                      : 
**                  Pin                                    : PTB9/SPI1_PCS1/UART3_CTS_b/FB_AD20
**                  Initial pin direction                  : Input
**                  Initial pin event                      : Disabled
**                  Lock initialization function           : no
**            Bit field                                    : 
**              Field name                                 : ShieldD4
**              Pins                                       : 1
**                Pin                                      : 
**                  Pin                                    : PTB23/SPI2_SIN/SPI0_PCS5/FB_AD28
**                  Initial pin direction                  : Input
**                  Initial pin event                      : Disabled
**                  Lock initialization function           : no
**          Initialization                                 : 
**            Auto initialization                          : yes
**            Event mask                                   : 
**              OnPortEvent                                : Disabled
**     Contents    :
**         Init                    - LDD_TDeviceData* ShieldGPIOB_Init(LDD_TUserData *UserDataPtr);
**         SetFieldValue           - void ShieldGPIOB_SetFieldValue(LDD_TDeviceData *DeviceDataPtr,...
**         GetFieldValue           - ShieldGPIOB_TFieldValue ShieldGPIOB_GetFieldValue(LDD_TDeviceData...
**         ClearFieldBits          - void ShieldGPIOB_ClearFieldBits(LDD_TDeviceData *DeviceDataPtr,...
**         SetFieldBits            - void ShieldGPIOB_SetFieldBits(LDD_TDeviceData *DeviceDataPtr,...
**         ToggleFieldBits         - void ShieldGPIOB_ToggleFieldBits(LDD_TDeviceData *DeviceDataPtr,...
**         SetFieldInputDirection  - void ShieldGPIOB_SetFieldInputDirection(LDD_TDeviceData *DeviceDataPtr,...
**         SetFieldOutputDirection - void ShieldGPIOB_SetFieldOutputDirection(LDD_TDeviceData *DeviceDataPtr,...
**
**     Copyright : 1997 - 2015 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file ShieldGPIOB.h
** @version 01.08
** @brief
**         The HAL GPIO component will provide a low level API for unified
**         access to general purpose digital input/output pins across
**         various device designs.
**
**         RTOS drivers using HAL GPIO API will be simpler and more
**         portable to various microprocessors.
*/         
/*!
**  @addtogroup ShieldGPIOB_module ShieldGPIOB module documentation
**  @{
*/         

#ifndef __ShieldGPIOB_H
#define __ShieldGPIOB_H

/* MODULE ShieldGPIOB. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "IO_Map.h"
#include "GPIO_PDD.h"
#include "PORT_PDD.h"

#include "Cpu.h"

#ifdef __cplusplus
extern "C" {
#endif 


/*! Peripheral base address of a device allocated by the component. This constant can be used directly in PDD macros. */
#define ShieldGPIOB_PRPH_BASE_ADDRESS  0x400FF040U
  
/*! Device data structure pointer used when auto initialization property is enabled. This constant can be passed as a first parameter to all component's methods. */
#define ShieldGPIOB_DeviceData  ((LDD_TDeviceData *)PE_LDD_GetDeviceStructure(PE_LDD_COMPONENT_ShieldGPIOB_ID))

/* Methods configuration constants - generated for all enabled component's methods */
#define ShieldGPIOB_Init_METHOD_ENABLED /*!< Init method of the component ShieldGPIOB is enabled (generated) */
#define ShieldGPIOB_SetFieldValue_METHOD_ENABLED /*!< SetFieldValue method of the component ShieldGPIOB is enabled (generated) */
#define ShieldGPIOB_GetFieldValue_METHOD_ENABLED /*!< GetFieldValue method of the component ShieldGPIOB is enabled (generated) */
#define ShieldGPIOB_ClearFieldBits_METHOD_ENABLED /*!< ClearFieldBits method of the component ShieldGPIOB is enabled (generated) */
#define ShieldGPIOB_SetFieldBits_METHOD_ENABLED /*!< SetFieldBits method of the component ShieldGPIOB is enabled (generated) */
#define ShieldGPIOB_ToggleFieldBits_METHOD_ENABLED /*!< ToggleFieldBits method of the component ShieldGPIOB is enabled (generated) */
#define ShieldGPIOB_SetFieldInputDirection_METHOD_ENABLED /*!< SetFieldInputDirection method of the component ShieldGPIOB is enabled (generated) */
#define ShieldGPIOB_SetFieldOutputDirection_METHOD_ENABLED /*!< SetFieldOutputDirection method of the component ShieldGPIOB is enabled (generated) */

/* Events configuration constants - generated for all enabled component's events */

/* Definition of bit field constants */
#define ShieldD2 ((LDD_GPIO_TBitField)0)
#define ShieldD4 ((LDD_GPIO_TBitField)1)

/* Definition of implementation constants */
#define ShieldGPIOB_ALLOCATED_PINS_MASK 0x00800200U /*!< Mask of all allocated pins from the port */
#define ShieldGPIOB_MODULE_BASE_ADDRESS PTB_BASE_PTR /*!< Name of macro used as the base address */
#define ShieldGPIOB_PORTCONTROL_BASE_ADDRESS PORTB_BASE_PTR /*!< Name of macro used as the base address */
#define ShieldGPIOB_AVAILABLE_EVENTS_MASK 0x00U /*!< Mask of all available events */
#define ShieldGPIOB_FIELD_0_PIN_0 LDD_GPIO_PIN_9 /*!< Constant for the pin in the field used in the method ConnectPin */
#define ShieldGPIOB_FIELD_1_PIN_0 LDD_GPIO_PIN_23 /*!< Constant for the pin in the field used in the method ConnectPin */
#define ShieldGPIOB_ShieldD2_START_BIT 9u /*!< Index of the starting bit of the bit field (0 represents LSB) */
#define ShieldGPIOB_ShieldD2_MASK 0x0200u /*!< Mask of the bits allocated by the bit field (within the port) */
#define ShieldGPIOB_ShieldD4_START_BIT 23u /*!< Index of the starting bit of the bit field (0 represents LSB) */
#define ShieldGPIOB_ShieldD4_MASK 0x00800000u /*!< Mask of the bits allocated by the bit field (within the port) */
/* Representation of unaligned data value of the port.
   Unsigned integer of proper width depending on the size of the GPIO port allocated.
   Typically the value of n-th bit represents the data for the n-th pin within the port.
   Such value is not abstracted from the physical position of the bits within the port. */
typedef uint32_t ShieldGPIOB_TPortValue;

/* Representation of right-aligned data value of the bit field.
   Typically the value of n-th bit represents the data of the n-th bit within the bit field (not within the port).
   There are used only so many lowest bits, as it is denoted by the width of the bit field.
   Such value is abstracted from the physical position of the bit field pins within the port.
   Equals to the type <compId>_TPortValue. */
typedef ShieldGPIOB_TPortValue ShieldGPIOB_TFieldValue;



/*
** ===================================================================
**     Method      :  ShieldGPIOB_Init (component GPIO_LDD)
*/
/*!
**     @brief
**         This method initializes the associated peripheral(s) and the
**         component internal variables. The method is called
**         automatically as a part of the application initialization
**         code.
**     @param
**         UserDataPtr     - Pointer to the RTOS device
**                           structure. This pointer will be passed to
**                           all events as parameter.
**     @return
**                         - Pointer to the dynamically allocated private
**                           structure or NULL if there was an error.
*/
/* ===================================================================*/
LDD_TDeviceData* ShieldGPIOB_Init(LDD_TUserData *UserDataPtr);

/*
** ===================================================================
**     Method      :  ShieldGPIOB_SetFieldValue (component GPIO_LDD)
*/
/*!
**     @brief
**         This method sets the output data value of the specified bit
**         field.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @param
**         Value           - Aligned data value to writting to the
**                           specified bit field. The bit 0 corresponds
**                           with the pin which has index 0 within the
**                           given bit field, the bit 1 corresponds with
**                           the pin which has index 1 within the given
**                           bit field, etc.
*/
/* ===================================================================*/
void ShieldGPIOB_SetFieldValue(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOB_TFieldValue Value);

/*
** ===================================================================
**     Method      :  ShieldGPIOB_GetFieldValue (component GPIO_LDD)
*/
/*!
**     @brief
**         This method returns the current input data of the specified
**         field.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to reading. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @return
**                         - Aligned current port input value masked for
**                           allocated pins of the field. The bit 0
**                           corresponds with the pin which has index 0
**                           within the given bit field, the bit 1
**                           corresponds with the pin which has index 1
**                           within the given bit field, etc.
*/
/* ===================================================================*/
ShieldGPIOB_TFieldValue ShieldGPIOB_GetFieldValue(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field);

/*
** ===================================================================
**     Method      :  ShieldGPIOB_ClearFieldBits (component GPIO_LDD)
*/
/*!
**     @brief
**         This method drives the specified bits of the specified bit
**         field to the inactive level.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @param
**         Mask            - Aligned mask of bits to setting the
**                           inactive level. Each field pin has
**                           corresponding bit in the mask. Bit value 0
**                           means not selected bit, bit value 1 means
**                           selected bit. The bit 0 corresponds with
**                           the pin which has index 0 within the given
**                           bit field, the bit 1 corresponds with the
**                           pin which has index 1 within the given bit
**                           field, etc.
*/
/* ===================================================================*/
void ShieldGPIOB_ClearFieldBits(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOB_TFieldValue Mask);

/*
** ===================================================================
**     Method      :  ShieldGPIOB_SetFieldBits (component GPIO_LDD)
*/
/*!
**     @brief
**         This method drives the specified bits of the specified bit
**         field to the active level.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @param
**         Mask            - Aligned mask of bits to setting the
**                           active level. Each field pin has
**                           corresponding bit in the mask. Bit value 0
**                           means not selected bit, bit value 1 means
**                           selected bit. The bit 0 corresponds with
**                           the pin which has index 0 within the given
**                           bit field, the bit 1 corresponds with the
**                           pin which has index 1 within the given bit
**                           field, etc.
*/
/* ===================================================================*/
void ShieldGPIOB_SetFieldBits(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOB_TFieldValue Mask);

/*
** ===================================================================
**     Method      :  ShieldGPIOB_ToggleFieldBits (component GPIO_LDD)
*/
/*!
**     @brief
**         This method inverts the specified bits of the specified bit
**         field to other level.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @param
**         Mask            - Aligned mask of bits to inverting the
**                           current level. Each field pin has
**                           corresponding bit in the mask. Bit value 0
**                           means not selected bit, bit value 1 means
**                           selected bit. The bit 0 corresponds with
**                           the pin which has index 0 within the given
**                           bit field, the bit 1 corresponds with the
**                           pin which has index 1 within the given bit
**                           field, etc.
*/
/* ===================================================================*/
void ShieldGPIOB_ToggleFieldBits(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOB_TFieldValue Mask);

/*
** ===================================================================
**     Method      :  ShieldGPIOB_SetFieldInputDirection (component GPIO_LDD)
*/
/*!
**     @brief
**         This method sets all pins of the field to the input
**         direction.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
*/
/* ===================================================================*/
void ShieldGPIOB_SetFieldInputDirection(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field);

/*
** ===================================================================
**     Method      :  ShieldGPIOB_SetFieldOutputDirection (component GPIO_LDD)
*/
/*!
**     @brief
**         This method sets all pins of the field to the output
**         direction.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to set to the output
**                           direction. Bit fields are defined during
**                           design time and for each bit field there is
**                           a generated constant.
**     @param
**         Value           - Aligned data value to appear on the
**                           bit field pins after they have been
**                           switched to the output direction.
*/
/* ===================================================================*/
void ShieldGPIOB_SetFieldOutputDirection(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOB_TFieldValue Value);

/* END ShieldGPIOB. */

#ifdef __cplusplus
}  /* extern "C" */
#endif 

#endif
/* ifndef __ShieldGPIOB_H */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.5 [05.21]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
