/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : ShieldGPIOD.c
**     Project     : CM-K60D
**     Processor   : MK64FN1M0VLQ12
**     Component   : GPIO_LDD
**     Version     : Component 01.128, Driver 01.08, CPU db: 3.00.000
**     Repository  : Kinetis
**     Compiler    : GNU C Compiler
**     Date/Time   : 2015-07-30, 16:10, # CodeGen: 0
**     Abstract    :
**         The HAL GPIO component will provide a low level API for unified
**         access to general purpose digital input/output pins across
**         various device designs.
**
**         RTOS drivers using HAL GPIO API will be simpler and more
**         portable to various microprocessors.
**     Settings    :
**          Component name                                 : ShieldGPIOD
**          Port                                           : PTD
**          Port width                                     : 32 bits
**          Mask of allocated pins                         : 0xF
**          Interrupt service/event                        : Disabled
**          Bit fields                                     : 4
**            Bit field                                    : 
**              Field name                                 : ShieldD10
**              Pins                                       : 1
**                Pin                                      : 
**                  Pin                                    : PTD0/LLWU_P12/SPI0_PCS0/UART2_RTS_b/FTM3_CH0/FB_ALE/FB_CS1_b/FB_TS_b
**                  Initial pin direction                  : Input
**                  Initial pin event                      : Disabled
**                  Lock initialization function           : no
**            Bit field                                    : 
**              Field name                                 : ShieldD11
**              Pins                                       : 1
**                Pin                                      : 
**                  Pin                                    : PTD2/LLWU_P13/SPI0_SOUT/UART2_RX/FTM3_CH2/FB_AD4/I2C0_SCL
**                  Initial pin direction                  : Input
**                  Initial pin event                      : Disabled
**                  Lock initialization function           : no
**            Bit field                                    : 
**              Field name                                 : ShieldD12
**              Pins                                       : 1
**                Pin                                      : 
**                  Pin                                    : PTD3/SPI0_SIN/UART2_TX/FTM3_CH3/FB_AD3/I2C0_SDA
**                  Initial pin direction                  : Input
**                  Initial pin event                      : Disabled
**                  Lock initialization function           : no
**            Bit field                                    : 
**              Field name                                 : ShieldD13
**              Pins                                       : 1
**                Pin                                      : 
**                  Pin                                    : ADC0_SE5b/PTD1/SPI0_SCK/UART2_CTS_b/FTM3_CH1/FB_CS0_b
**                  Initial pin direction                  : Input
**                  Initial pin event                      : Disabled
**                  Lock initialization function           : no
**          Initialization                                 : 
**            Auto initialization                          : yes
**            Event mask                                   : 
**              OnPortEvent                                : Disabled
**     Contents    :
**         Init                    - LDD_TDeviceData* ShieldGPIOD_Init(LDD_TUserData *UserDataPtr);
**         SetFieldValue           - void ShieldGPIOD_SetFieldValue(LDD_TDeviceData *DeviceDataPtr,...
**         GetFieldValue           - ShieldGPIOD_TFieldValue ShieldGPIOD_GetFieldValue(LDD_TDeviceData...
**         ClearFieldBits          - void ShieldGPIOD_ClearFieldBits(LDD_TDeviceData *DeviceDataPtr,...
**         SetFieldBits            - void ShieldGPIOD_SetFieldBits(LDD_TDeviceData *DeviceDataPtr,...
**         ToggleFieldBits         - void ShieldGPIOD_ToggleFieldBits(LDD_TDeviceData *DeviceDataPtr,...
**         SetFieldInputDirection  - void ShieldGPIOD_SetFieldInputDirection(LDD_TDeviceData *DeviceDataPtr,...
**         SetFieldOutputDirection - void ShieldGPIOD_SetFieldOutputDirection(LDD_TDeviceData *DeviceDataPtr,...
**
**     Copyright : 1997 - 2015 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file ShieldGPIOD.c
** @version 01.08
** @brief
**         The HAL GPIO component will provide a low level API for unified
**         access to general purpose digital input/output pins across
**         various device designs.
**
**         RTOS drivers using HAL GPIO API will be simpler and more
**         portable to various microprocessors.
*/         
/*!
**  @addtogroup ShieldGPIOD_module ShieldGPIOD module documentation
**  @{
*/         

/* MODULE ShieldGPIOD. */

#include "ShieldGPIOD.h"
/* {Default RTOS Adapter} No RTOS includes */
#include "IO_Map.h"

#ifdef __cplusplus
extern "C" {
#endif 

typedef struct {
  LDD_TUserData *UserData;             /* RTOS device data structure */
} ShieldGPIOD_TDeviceData, *ShieldGPIOD_TDeviceDataPtr; /* Device data structure type */
/* {Default RTOS Adapter} Static object used for simulation of dynamic driver memory allocation */
static ShieldGPIOD_TDeviceData DeviceDataPrv__DEFAULT_RTOS_ALLOC;
/*
** ===================================================================
**     Method      :  ShieldGPIOD_Init (component GPIO_LDD)
*/
/*!
**     @brief
**         This method initializes the associated peripheral(s) and the
**         component internal variables. The method is called
**         automatically as a part of the application initialization
**         code.
**     @param
**         UserDataPtr     - Pointer to the RTOS device
**                           structure. This pointer will be passed to
**                           all events as parameter.
**     @return
**                         - Pointer to the dynamically allocated private
**                           structure or NULL if there was an error.
*/
/* ===================================================================*/
LDD_TDeviceData* ShieldGPIOD_Init(LDD_TUserData *UserDataPtr)
{
  /* Allocate LDD device structure */
  ShieldGPIOD_TDeviceData *DeviceDataPrv;

  /* {Default RTOS Adapter} Driver memory allocation: Dynamic allocation is simulated by a pointer to the static object */
  DeviceDataPrv = &DeviceDataPrv__DEFAULT_RTOS_ALLOC;
  /* Save RTOS Device structure */
  DeviceDataPrv->UserData = UserDataPtr; /* Store the RTOS device structure */
  /* Enable device clock gate */
  /* SIM_SCGC5: PORTD=1 */
  SIM_SCGC5 |= SIM_SCGC5_PORTD_MASK;
  /* GPIOD_PDDR: PDD&=~0x0F */
  GPIOD_PDDR &= (uint32_t)~(uint32_t)(GPIO_PDDR_PDD(0x0F));
  /* Initialization of pin routing */
  /* PORTD_PCR0: ISF=0,MUX=1 */
  PORTD_PCR0 = (uint32_t)((PORTD_PCR0 & (uint32_t)~(uint32_t)(
                PORT_PCR_ISF_MASK |
                PORT_PCR_MUX(0x06)
               )) | (uint32_t)(
                PORT_PCR_MUX(0x01)
               ));
  /* PORTD_PCR2: ISF=0,MUX=1 */
  PORTD_PCR2 = (uint32_t)((PORTD_PCR2 & (uint32_t)~(uint32_t)(
                PORT_PCR_ISF_MASK |
                PORT_PCR_MUX(0x06)
               )) | (uint32_t)(
                PORT_PCR_MUX(0x01)
               ));
  /* PORTD_PCR3: ISF=0,MUX=1 */
  PORTD_PCR3 = (uint32_t)((PORTD_PCR3 & (uint32_t)~(uint32_t)(
                PORT_PCR_ISF_MASK |
                PORT_PCR_MUX(0x06)
               )) | (uint32_t)(
                PORT_PCR_MUX(0x01)
               ));
  /* PORTD_PCR1: ISF=0,MUX=1 */
  PORTD_PCR1 = (uint32_t)((PORTD_PCR1 & (uint32_t)~(uint32_t)(
                PORT_PCR_ISF_MASK |
                PORT_PCR_MUX(0x06)
               )) | (uint32_t)(
                PORT_PCR_MUX(0x01)
               ));
  /* Registration of the device structure */
  PE_LDD_RegisterDeviceStructure(PE_LDD_COMPONENT_ShieldGPIOD_ID,DeviceDataPrv);
  return ((LDD_TDeviceData *)DeviceDataPrv);
}

/*
** ===================================================================
**     Method      :  ShieldGPIOD_SetFieldValue (component GPIO_LDD)
*/
/*!
**     @brief
**         This method sets the output data value of the specified bit
**         field.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @param
**         Value           - Aligned data value to writting to the
**                           specified bit field. The bit 0 corresponds
**                           with the pin which has index 0 within the
**                           given bit field, the bit 1 corresponds with
**                           the pin which has index 1 within the given
**                           bit field, etc.
*/
/* ===================================================================*/
void ShieldGPIOD_SetFieldValue(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOD_TFieldValue Value)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD10: {                  /* bit field #0 */
      GPIO_PDD_SetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS,
        (
          GPIO_PDD_GetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS)
          & ((ShieldGPIOD_TPortValue)(~((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD10_MASK)))
        )
        | (
          Value
          & ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD10_MASK)
        )
      );
      break;
    }
    case ShieldD11: {                  /* bit field #1 */
      GPIO_PDD_SetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS,
        (
          GPIO_PDD_GetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS)
          & ((ShieldGPIOD_TPortValue)(~((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD11_MASK)))
        )
        | (
          ((ShieldGPIOD_TPortValue)(Value << ShieldGPIOD_ShieldD11_START_BIT))
          & ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD11_MASK)
        )
      );
      break;
    }
    case ShieldD12: {                  /* bit field #2 */
      GPIO_PDD_SetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS,
        (
          GPIO_PDD_GetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS)
          & ((ShieldGPIOD_TPortValue)(~((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD12_MASK)))
        )
        | (
          ((ShieldGPIOD_TPortValue)(Value << ShieldGPIOD_ShieldD12_START_BIT))
          & ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD12_MASK)
        )
      );
      break;
    }
    case ShieldD13: {                  /* bit field #3 */
      GPIO_PDD_SetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS,
        (
          GPIO_PDD_GetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS)
          & ((ShieldGPIOD_TPortValue)(~((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD13_MASK)))
        )
        | (
          ((ShieldGPIOD_TPortValue)(Value << ShieldGPIOD_ShieldD13_START_BIT))
          & ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD13_MASK)
        )
      );
      break;
    }
    default:
      break;                           /* Invalid Field is not treated, result is undefined */
  } /* switch (Field) */
}

/*
** ===================================================================
**     Method      :  ShieldGPIOD_GetFieldValue (component GPIO_LDD)
*/
/*!
**     @brief
**         This method returns the current input data of the specified
**         field.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to reading. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @return
**                         - Aligned current port input value masked for
**                           allocated pins of the field. The bit 0
**                           corresponds with the pin which has index 0
**                           within the given bit field, the bit 1
**                           corresponds with the pin which has index 1
**                           within the given bit field, etc.
*/
/* ===================================================================*/
ShieldGPIOD_TFieldValue ShieldGPIOD_GetFieldValue(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD10: {                  /* bit field #0 */
      return
        (ShieldGPIOD_TFieldValue)(
          GPIO_PDD_GetPortDataInput(ShieldGPIOD_MODULE_BASE_ADDRESS)
          & (ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD10_MASK
        );
    }
    case ShieldD11: {                  /* bit field #1 */
      return
        (ShieldGPIOD_TFieldValue)(
          (
            GPIO_PDD_GetPortDataInput(ShieldGPIOD_MODULE_BASE_ADDRESS)
            & (ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD11_MASK
          )
          >> ShieldGPIOD_ShieldD11_START_BIT
        );
    }
    case ShieldD12: {                  /* bit field #2 */
      return
        (ShieldGPIOD_TFieldValue)(
          (
            GPIO_PDD_GetPortDataInput(ShieldGPIOD_MODULE_BASE_ADDRESS)
            & (ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD12_MASK
          )
          >> ShieldGPIOD_ShieldD12_START_BIT
        );
    }
    case ShieldD13: {                  /* bit field #3 */
      return
        (ShieldGPIOD_TFieldValue)(
          (
            GPIO_PDD_GetPortDataInput(ShieldGPIOD_MODULE_BASE_ADDRESS)
            & (ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD13_MASK
          )
          >> ShieldGPIOD_ShieldD13_START_BIT
        );
    }
    default:
      break;                           /* Invalid BitField is not treated, result is undefined */
  } /* switch (Field) */
  return (ShieldGPIOD_TFieldValue)0U;
}

/*
** ===================================================================
**     Method      :  ShieldGPIOD_ClearFieldBits (component GPIO_LDD)
*/
/*!
**     @brief
**         This method drives the specified bits of the specified bit
**         field to the inactive level.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @param
**         Mask            - Aligned mask of bits to setting the
**                           inactive level. Each field pin has
**                           corresponding bit in the mask. Bit value 0
**                           means not selected bit, bit value 1 means
**                           selected bit. The bit 0 corresponds with
**                           the pin which has index 0 within the given
**                           bit field, the bit 1 corresponds with the
**                           pin which has index 1 within the given bit
**                           field, etc.
*/
/* ===================================================================*/
void ShieldGPIOD_ClearFieldBits(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOD_TFieldValue Mask)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD10: {                  /* bit field #0 */
      GPIO_PDD_ClearPortDataOutputMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD10_MASK)
        & Mask
      );
      break;
    }
    case ShieldD11: {                  /* bit field #1 */
      GPIO_PDD_ClearPortDataOutputMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD11_MASK)
        & ((ShieldGPIOD_TPortValue)(Mask << ShieldGPIOD_ShieldD11_START_BIT))
      );
      break;
    }
    case ShieldD12: {                  /* bit field #2 */
      GPIO_PDD_ClearPortDataOutputMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD12_MASK)
        & ((ShieldGPIOD_TPortValue)(Mask << ShieldGPIOD_ShieldD12_START_BIT))
      );
      break;
    }
    case ShieldD13: {                  /* bit field #3 */
      GPIO_PDD_ClearPortDataOutputMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD13_MASK)
        & ((ShieldGPIOD_TPortValue)(Mask << ShieldGPIOD_ShieldD13_START_BIT))
      );
      break;
    }
    default:
      break;                           /* Invalid Field is not treated, result is undefined */
  } /* switch (Field) */
}

/*
** ===================================================================
**     Method      :  ShieldGPIOD_SetFieldBits (component GPIO_LDD)
*/
/*!
**     @brief
**         This method drives the specified bits of the specified bit
**         field to the active level.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @param
**         Mask            - Aligned mask of bits to setting the
**                           active level. Each field pin has
**                           corresponding bit in the mask. Bit value 0
**                           means not selected bit, bit value 1 means
**                           selected bit. The bit 0 corresponds with
**                           the pin which has index 0 within the given
**                           bit field, the bit 1 corresponds with the
**                           pin which has index 1 within the given bit
**                           field, etc.
*/
/* ===================================================================*/
void ShieldGPIOD_SetFieldBits(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOD_TFieldValue Mask)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD10: {                  /* bit field #0 */
      GPIO_PDD_SetPortDataOutputMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD10_MASK)
        & Mask
      );
      break;
    }
    case ShieldD11: {                  /* bit field #1 */
      GPIO_PDD_SetPortDataOutputMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD11_MASK)
        & ((ShieldGPIOD_TPortValue)(Mask << ShieldGPIOD_ShieldD11_START_BIT))
      );
      break;
    }
    case ShieldD12: {                  /* bit field #2 */
      GPIO_PDD_SetPortDataOutputMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD12_MASK)
        & ((ShieldGPIOD_TPortValue)(Mask << ShieldGPIOD_ShieldD12_START_BIT))
      );
      break;
    }
    case ShieldD13: {                  /* bit field #3 */
      GPIO_PDD_SetPortDataOutputMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD13_MASK)
        & ((ShieldGPIOD_TPortValue)(Mask << ShieldGPIOD_ShieldD13_START_BIT))
      );
      break;
    }
    default:
      break;                           /* Invalid Field is not treated, result is undefined */
  } /* switch (Field) */
}

/*
** ===================================================================
**     Method      :  ShieldGPIOD_ToggleFieldBits (component GPIO_LDD)
*/
/*!
**     @brief
**         This method inverts the specified bits of the specified bit
**         field to other level.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
**     @param
**         Mask            - Aligned mask of bits to inverting the
**                           current level. Each field pin has
**                           corresponding bit in the mask. Bit value 0
**                           means not selected bit, bit value 1 means
**                           selected bit. The bit 0 corresponds with
**                           the pin which has index 0 within the given
**                           bit field, the bit 1 corresponds with the
**                           pin which has index 1 within the given bit
**                           field, etc.
*/
/* ===================================================================*/
void ShieldGPIOD_ToggleFieldBits(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOD_TFieldValue Mask)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD10: {                  /* bit field #0 */
      GPIO_PDD_TogglePortDataOutputMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD10_MASK)
        & Mask
      );
      break;
    }
    case ShieldD11: {                  /* bit field #1 */
      GPIO_PDD_TogglePortDataOutputMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD11_MASK)
        & ((ShieldGPIOD_TPortValue)(Mask << ShieldGPIOD_ShieldD11_START_BIT))
      );
      break;
    }
    case ShieldD12: {                  /* bit field #2 */
      GPIO_PDD_TogglePortDataOutputMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD12_MASK)
        & ((ShieldGPIOD_TPortValue)(Mask << ShieldGPIOD_ShieldD12_START_BIT))
      );
      break;
    }
    case ShieldD13: {                  /* bit field #3 */
      GPIO_PDD_TogglePortDataOutputMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD13_MASK)
        & ((ShieldGPIOD_TPortValue)(Mask << ShieldGPIOD_ShieldD13_START_BIT))
      );
      break;
    }
    default:
      break;                           /* Invalid Field is not treated, result is undefined */
  } /* switch (Field) */
}

/*
** ===================================================================
**     Method      :  ShieldGPIOD_SetFieldInputDirection (component GPIO_LDD)
*/
/*!
**     @brief
**         This method sets all pins of the field to the input
**         direction.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to write. Bit fields are
**                           defined during design time and for each bit
**                           field there is a generated constant.
*/
/* ===================================================================*/
void ShieldGPIOD_SetFieldInputDirection(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD10: {                  /* bit field #0 */
      GPIO_PDD_SetPortInputDirectionMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ShieldGPIOD_ShieldD10_MASK
      );
      break;
    }
    case ShieldD11: {                  /* bit field #1 */
      GPIO_PDD_SetPortInputDirectionMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ShieldGPIOD_ShieldD11_MASK
      );
      break;
    }
    case ShieldD12: {                  /* bit field #2 */
      GPIO_PDD_SetPortInputDirectionMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ShieldGPIOD_ShieldD12_MASK
      );
      break;
    }
    case ShieldD13: {                  /* bit field #3 */
      GPIO_PDD_SetPortInputDirectionMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ShieldGPIOD_ShieldD13_MASK
      );
      break;
    }
    default:
      break;                           /* Invalid Field is not treated, result is undefined */
  } /* switch (Field) */
}

/*
** ===================================================================
**     Method      :  ShieldGPIOD_SetFieldOutputDirection (component GPIO_LDD)
*/
/*!
**     @brief
**         This method sets all pins of the field to the output
**         direction.
**     @param
**         DeviceDataPtr   - Device data structure
**                           pointer returned by [Init] method.
**     @param
**         Field           - Bit field to set to the output
**                           direction. Bit fields are defined during
**                           design time and for each bit field there is
**                           a generated constant.
**     @param
**         Value           - Aligned data value to appear on the
**                           bit field pins after they have been
**                           switched to the output direction.
*/
/* ===================================================================*/
void ShieldGPIOD_SetFieldOutputDirection(LDD_TDeviceData *DeviceDataPtr, LDD_GPIO_TBitField Field, ShieldGPIOD_TFieldValue Value)
{
  (void)DeviceDataPtr;                 /* Parameter is not used, suppress unused argument warning */
  switch (Field) {                     /* no break */
    case ShieldD10: {                  /* bit field #0 */
      GPIO_PDD_SetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)(
          GPIO_PDD_GetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS)
          & ((ShieldGPIOD_TPortValue)(
            ~((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD10_MASK)
          ))
        ))
        | (
          Value
          & ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD10_MASK)
        )
      );
      GPIO_PDD_SetPortOutputDirectionMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ShieldGPIOD_ShieldD10_MASK
      );
      break;
    }
    case ShieldD11: {                  /* bit field #1 */
      GPIO_PDD_SetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)(
          GPIO_PDD_GetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS)
          & ((ShieldGPIOD_TPortValue)(
            ~((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD11_MASK)
          ))
        ))
        | (
          ((ShieldGPIOD_TPortValue)(Value << ShieldGPIOD_ShieldD11_START_BIT))
          & ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD11_MASK)
        )
      );
      GPIO_PDD_SetPortOutputDirectionMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ShieldGPIOD_ShieldD11_MASK
      );
      break;
    }
    case ShieldD12: {                  /* bit field #2 */
      GPIO_PDD_SetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)(
          GPIO_PDD_GetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS)
          & ((ShieldGPIOD_TPortValue)(
            ~((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD12_MASK)
          ))
        ))
        | (
          ((ShieldGPIOD_TPortValue)(Value << ShieldGPIOD_ShieldD12_START_BIT))
          & ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD12_MASK)
        )
      );
      GPIO_PDD_SetPortOutputDirectionMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ShieldGPIOD_ShieldD12_MASK
      );
      break;
    }
    case ShieldD13: {                  /* bit field #3 */
      GPIO_PDD_SetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ((ShieldGPIOD_TPortValue)(
          GPIO_PDD_GetPortDataOutput(ShieldGPIOD_MODULE_BASE_ADDRESS)
          & ((ShieldGPIOD_TPortValue)(
            ~((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD13_MASK)
          ))
        ))
        | (
          ((ShieldGPIOD_TPortValue)(Value << ShieldGPIOD_ShieldD13_START_BIT))
          & ((ShieldGPIOD_TPortValue)ShieldGPIOD_ShieldD13_MASK)
        )
      );
      GPIO_PDD_SetPortOutputDirectionMask(ShieldGPIOD_MODULE_BASE_ADDRESS,
        ShieldGPIOD_ShieldD13_MASK
      );
      break;
    }
    default:
      break;                           /* Invalid Field is not treated, result is undefined */
  } /* switch (Field) */
}

/* END ShieldGPIOD. */

#ifdef __cplusplus
}  /* extern "C" */
#endif 

/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.5 [05.21]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
